unit Test.UClass.TAritmeticaBasica;
{

  Delphi DUnit Test Case
  ----------------------
  This unit contains a skeleton test case class generated by the Test Case Wizard.
  Modify the generated code to correctly setup and call the methods from the unit 
  being tested.

}


//==============================================================================
//
//  I N T E R F A C E
//
//==============================================================================
interface

uses
//-convert-  TestFramework,
  DUnitX.TestFramework, DUnitX.DUnitCompatibility,
  System.Generics.Collections, UClass.TAritmeticaBasica;

type
  // Test methods for class TAritmeticaBasica
  TestTAritmeticaBasica = class(TTestCase)
  strict private
    FAritmeticaBasica: TAritmeticaBasica;
    FFactorizacion:TIntegerList;
  public
    procedure SetUp; override;
    procedure TearDown; override;
  published
    procedure TestMaximoComunDivisor;

    procedure TestEsNumeroPrimo_0;
    procedure TestEsNumeroPrimo_1;
    procedure TestEsNumeroPrimo_2;
    procedure TestEsNumeroPrimo_3;
    procedure TestEsNumeroPrimo_4;
    procedure TestEsNumeroPrimo_20;
    procedure TestEsNumeroPrimo_11;
    procedure TestEsNumeroPrimo_17;
    procedure TestEsNumeroPrimo_18;
    procedure TestEsNumeroPrimo_331;
    procedure TestEsNumeroPrimo_5557;

    procedure TestMinimoComunMultiplo;

    procedure TestFactorizacion_0;
    procedure TestFactorizacion_1;
    procedure TestFactorizacion_2;
    procedure TestFactorizacion_4;
    procedure TestFactorizacion_10;
    procedure TestFactorizacion_18;
    procedure TestFactorizacion_528;

  end;


//==============================================================================
//
//  I M P L E M E N T A C I O N
//
//==============================================================================
implementation

uses
  System.SysUtils, DUnitX.Assert;



procedure TestTAritmeticaBasica.SetUp;
begin
  // Crear el objeto que vamos a probar
  FAritmeticaBasica := TAritmeticaBasica.Create;
  FFactorizacion := TIntegerList.Create;
end;

procedure TestTAritmeticaBasica.TearDown;
begin
  // Liberar el objeto de prueba
  FAritmeticaBasica.Free;
  FAritmeticaBasica := nil;
  FreeAndNil(FFactorizacion);
end;

procedure TestTAritmeticaBasica.TestEsNumeroPrimo_0;
begin
  Assert.IsFalse(FAritmeticaBasica.EsNumeroPrimo(0));
end;
procedure TestTAritmeticaBasica.TestEsNumeroPrimo_1;
begin
  Assert.IsTrue(FAritmeticaBasica.EsNumeroPrimo(1));
end;
procedure TestTAritmeticaBasica.TestEsNumeroPrimo_2;
begin
  Assert.IsTrue(FAritmeticaBasica.EsNumeroPrimo(2));
end;
procedure TestTAritmeticaBasica.TestEsNumeroPrimo_3;
begin
  Assert.IsTrue(FAritmeticaBasica.EsNumeroPrimo(3));
end;
procedure TestTAritmeticaBasica.TestEsNumeroPrimo_4;
begin
  // MAL
  Assert.IsTrue(FAritmeticaBasica.EsNumeroPrimo(4), 'Error, nmero 4 debera devolver que es primo');
end;
procedure TestTAritmeticaBasica.TestEsNumeroPrimo_11;
begin
  Assert.IsTrue(FAritmeticaBasica.EsNumeroPrimo(11));
end;
procedure TestTAritmeticaBasica.TestEsNumeroPrimo_17;
begin
  Assert.IsTrue(FAritmeticaBasica.EsNumeroPrimo(17));
end;
procedure TestTAritmeticaBasica.TestEsNumeroPrimo_18;
begin
  Assert.IsFalse(FAritmeticaBasica.EsNumeroPrimo(18));
end;
procedure TestTAritmeticaBasica.TestEsNumeroPrimo_20;
begin
  Assert.IsFalse(FAritmeticaBasica.EsNumeroPrimo(20));
end;
procedure TestTAritmeticaBasica.TestEsNumeroPrimo_331;
begin
  Assert.IsTrue(FAritmeticaBasica.EsNumeroPrimo(331));
end;
procedure TestTAritmeticaBasica.TestEsNumeroPrimo_5557;
begin
  Assert.IsTrue(FAritmeticaBasica.EsNumeroPrimo(5557));
end;


procedure TestTAritmeticaBasica.TestMaximoComunDivisor;
var
  ReturnValue: Int64;
  ANumero2: Int64;
  ANumero1: Int64;
begin
  ReturnValue := FAritmeticaBasica.MaximoComunDivisor(ANumero1, ANumero2);
end;

procedure TestTAritmeticaBasica.TestMinimoComunMultiplo;
var
  ReturnValue: Int64;
  ANumero2: Int64;
  ANumero1: Int64;
begin
  ReturnValue := FAritmeticaBasica.MinimoComunMultiplo(ANumero1, ANumero2);
end;


procedure TestTAritmeticaBasica.TestFactorizacion_0;
begin
  FAritmeticaBasica.Factorizacion(0, FFactorizacion);
  Assert.AreEqual(FFactorizacion.Count, 0, '0 no se puede descomponer');
end;

procedure TestTAritmeticaBasica.TestFactorizacion_1;
begin
  FAritmeticaBasica.Factorizacion(1, FFactorizacion);
  Assert.IsTrue(FFactorizacion.Count = 0, '1 no se puede descomponer');
end;

procedure TestTAritmeticaBasica.TestFactorizacion_2;
begin
  // MAL
  FAritmeticaBasica.Factorizacion(2, FFactorizacion);
  Assert.IsFalse(FFactorizacion.Count = 1, '2 no se puede descomponer, es numero primo');
end;

procedure TestTAritmeticaBasica.TestFactorizacion_4;
begin
  FFactorizacion.Clear;
  FAritmeticaBasica.Factorizacion(4, FFactorizacion);
  Assert.IsTrue((FFactorizacion.Count = 2) and (FFactorizacion[0] = 2) and (FFactorizacion[1] = 2), 'Se esperaban 2 factores; 2,2');
end;

procedure TestTAritmeticaBasica.TestFactorizacion_10;
begin
  FFactorizacion.Clear;
  FAritmeticaBasica.Factorizacion(10, FFactorizacion);
  CheckTrue((FFactorizacion.Count = 2) and (FFactorizacion[0] = 2) and (FFactorizacion[1] = 5), 'Se esperaban 2 factores; 2,5');
end;

procedure TestTAritmeticaBasica.TestFactorizacion_18;
begin
  FFactorizacion.Clear;
  FAritmeticaBasica.Factorizacion(18, FFactorizacion);
  Assert.IsTrue((FFactorizacion.Count = 3) and (FFactorizacion[0] = 2) and
            (FFactorizacion[1] = 3) and (FFactorizacion[2] = 3), 'Se esperaban 3 factores; 2,3,3');
end;

procedure TestTAritmeticaBasica.TestFactorizacion_528;
begin
  FFactorizacion.Clear;
  FAritmeticaBasica.Factorizacion(528, FFactorizacion);
  Assert.IsTrue((FFactorizacion.Count = 6) and
            (FFactorizacion[0] = 2) and (FFactorizacion[1] = 2) and (FFactorizacion[2] = 2) and
            (FFactorizacion[3] = 2) and (FFactorizacion[4] = 3) and (FFactorizacion[5] = 11),
            'Se esperaban 6 factores; 2,2,2,2,3,11');
end;


//==============================================================================
//
//  I N I T I A L I Z A T I O N
//
//==============================================================================
initialization
  // Register any test cases with the test runner
  TDUnitX.RegisterTestFixture(TestTAritmeticaBasica);


end.

